package nccloud.web.hrwa.wagrade.action;

import java.util.HashMap;
import java.util.Map;

import nc.itf.hr.wa.IWaGradeQueryService;
import nc.vo.bd.pub.NODE_TYPE;
import nc.vo.uif2.LoginContext;
import nc.vo.wa.grade.AggWaGradeVO;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.hrwa.pub.IWATempletConst;
import nccloud.web.uapbd.commons.web.ParamUtils;


public class WaGradeGetParentDataAction extends HRCommonAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		LoginContext context = HRNccUtils.getLoginContext(param);
		String pkWaGrd = param.getString("pk_wa_grd", null);
		String pkOrg = param.getString("pk_org", null);
		String opType = param.getString("op_type", "edit");
		if (pkWaGrd == null) {
			return null;
		}
		String appCode = NODE_TYPE.ORG_NODE.equals(context.getNodeType()) ? IWATempletConst.APPCODE_WAGRADE_ORG
				: IWATempletConst.APPCODE_WAGRADE_GRP;
		AggWaGradeVO gradeVo = (AggWaGradeVO) ServiceLocator.find(IWaGradeQueryService.class)
				.queryAggWagradeByGrdPK(pkWaGrd);
		if (gradeVo == null) {
			return null;
		} 
		Map<String, Object> resultMap = new HashMap<String, Object>();
		//
		resultMap.put("gradeForm", gradeVo.getParentVO());
		// 
		resultMap.put("prmlvForm", gradeVo.getTableVO("wa_prmlv"));
		// 
		resultMap.put("seclvForm", gradeVo.getTableVO("wa_seclv"));
		return resultMap;
	}
	
	
}
