package nccloud.web.hrwa.wagrade.action;

import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;

import nc.itf.hr.wa.IWaGradeQueryService;
import nc.itf.hr.wa.IWaGradeService;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.wa.grade.AggWaGradeVO;
import nc.vo.wa.grade.IWaGradeCommonDef;
import nc.vo.wa.grade.WaGradeVO;
import nc.vo.wa.grade.WaPrmlvVO;
import nc.vo.wa.grade.WaPsnhiVO;
import nc.vo.wa.grade.WaSeclvVO;
import nc.vo.wa.item.WaItemVO;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hrwa.wagrade.action.util.WaGradeCommon;
import nccloud.web.hrwa.wagrade.save.CopyHelper;
import nccloud.web.hrwa.wagrade.save.GetSaveParamHelper;
import nccloud.web.hrwa.wagrade.save.UpdateHelper;
import nccloud.web.hrwa.wagrade.validation.WaGradeValidate;
import nccloud.web.hrwa.wagrade.vo.WaGradeSaveCommonProp;
import nccloud.web.uapbd.commons.web.ParamUtils;
/**
 * 
 * 20197133:05:41
 * msw
 * нʱ׼ñ
 */
public class WaGradeSaveAction extends HRCommonAction {
	
	private CopyHelper copyHelper = null;
	private GetSaveParamHelper getSaveParamHelper = null;
	private UpdateHelper updateHelper = null;

	private void initParam(WaGradeSaveCommonProp commonPorp) {
		copyHelper = new CopyHelper(commonPorp);
		getSaveParamHelper = new GetSaveParamHelper(commonPorp);
		updateHelper = new UpdateHelper(commonPorp);
	}
	@SuppressWarnings("unchecked")
	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		WaGradeSaveCommonProp commonPorp=new WaGradeSaveCommonProp();
		initParam(commonPorp);
		
		ParamUtils param = new ParamUtils(request);
		Map<String, String> paramMap = new HashMap<String, String>();
		paramMap = param.getMap("base_param", paramMap);
		String opType = paramMap.get("op_type");// ǰ˱봫add,copy,edit
		Map<String, Object> formDataMap = new HashMap<String, Object>();
		formDataMap = getSaveParamHelper.getWebAggWaGradeVO(request);
		AggWaGradeVO aggVO = (AggWaGradeVO) formDataMap.get("aggvo");

		WaGradeValidate validate = new WaGradeValidate();
		validate.validatePrvSecIsNull(aggVO);

		WaGradeVO parentOldVO = null;
		String pkWaGrdOld = "";// ȡǰûƺ
		WaGradeVO parentNewVO = aggVO.getParentVO();
		if ("edit".equals(opType) || "copy".equals(opType)) {
			AggWaGradeVO gradeVo = (AggWaGradeVO) ServiceLocator.find(IWaGradeQueryService.class)
					.queryAggWagradeByGrdPK(aggVO.getParentVO().getPk_wa_grd());
			// ԭнʱ׼VO
			parentOldVO = gradeVo.getParentVO();
			// ԭнʱ׼
			pkWaGrdOld = parentOldVO.getPk_wa_grd();
			// ȡǰнʱ׼飬ûƺ
			commonPorp.setWaPrmlvVOArrOld((WaPrmlvVO[]) gradeVo.getTableVO(IWaGradeCommonDef.WA_PRMLV));
			// ȡǰнʱ׼飬ûƺ
			commonPorp.setWaSeclvVOArrOld((WaSeclvVO[]) gradeVo.getTableVO(IWaGradeCommonDef.WA_SECLV));
			// ȡǰнʱ׼Ա飬ûƺ
			commonPorp.setWaPsnhiVOArrOld((WaPsnhiVO[]) gradeVo.getTableVO(IWaGradeCommonDef.WA_PSNHI));	
		}
		// ԭ൵ʶ
		commonPorp.setMultOld((parentOldVO == null) ? false : parentOldVO.getIsmultsec().booleanValue());
		// ԭʶ
		commonPorp.setRangeOld((parentOldVO == null) ? false : parentOldVO.getIsrange().booleanValue());
		// ֶ൵ʶ
		commonPorp.setMultNew(parentNewVO.getIsmultsec().booleanValue());
		// ֿʶ
		commonPorp.setRangeNew(parentNewVO.getIsrange().booleanValue());
		
		WaPrmlvVO[] waPrmlvVOArr = (WaPrmlvVO[]) aggVO.getTableVO(IWaGradeCommonDef.WA_PRMLV);
		WaSeclvVO[] waSeclvVOArr = (WaSeclvVO[]) aggVO.getTableVO(IWaGradeCommonDef.WA_SECLV);
		// ݣǶ൵޸״̬£֮ǰĵɾ
		if ("edit".equals(opType) && !commonPorp.isMultNew()) {
			if (waSeclvVOArr != null && waSeclvVOArr.length > 0) {
				for (int i = 0; i < waSeclvVOArr.length; i++) {
					waSeclvVOArr[i].setStatus(VOStatus.DELETED);
				}
			}
		}
		
		//add by@chenzfжǷŷݣ֤¼нݵϼǷΪ 2021-4-7 16:23:52 begin
		if(parentNewVO.getIsgroup() != null && parentNewVO.getIsgroup().booleanValue() && parentNewVO.getIsscope() != null && parentNewVO.getIsscope().booleanValue()) {
			String msg = "";
			for(WaPrmlvVO vo : waPrmlvVOArr) {
				String levelname = vo.getLevelname();
				if(vo.getIsgroup() != null && vo.getIsgroup().booleanValue()) {
					continue;
				} else {
					if(StringUtils.isBlank(vo.getPk_wa_fatheprmlv())) {
						msg = msg + levelname + ",";
					}
				}
			}
			if(msg.length() > 0) {
				throw new BusinessException("нϼΪ:["+msg.substring(0, msg.length() - 1)+"]");
			}
		}
		//жϼ׼¼ֻܴһսһн
		if(StringUtils.isNotBlank(parentNewVO.getPk_wagrade_top())) {
			//1Ϊн  2Ϊн3Ϊս
			String standard_type = parentNewVO.getStandard_type();
			String pk_wagrade_top = parentNewVO.getPk_wagrade_top();
			String pk_wa_grade = parentNewVO.getPk_wa_grd();
			UFBoolean check = ServiceLocator.find(IWaGradeQueryService.class).checkWaGrade(pk_wagrade_top, standard_type, pk_wa_grade);
			if(check.booleanValue()) {
				throw new BusinessException("ͬһϼ׼𣬲ܴ2ͬ¹ʻս");
			}
		}
		//жǷ¼ӼǵĻжǷΪ൵
		if(parentNewVO.getIsscope() != null && parentNewVO.getIsscope().booleanValue()) {
			UFBoolean ismultsec = parentNewVO.getIsmultsec();
			if(ismultsec == null || !ismultsec.booleanValue()) {
				throw new BusinessException("ȷΧ˾ӼΪǣ൵Ϊ");
			}
		}
		//add by@chenzfжǷŷݣ֤¼нݵϼǷΪ 2021-4-7 16:23:52 end
		
		// жϼ͵Ƿӻɾ
		Map<String, Boolean> isAddOrDelMap = getSaveParamHelper.prvAndSevIsAddOrDel(aggVO);
		Boolean isPrmlvAddOrDel = isAddOrDelMap.get(IWaGradeCommonDef.WA_PRMLV);
		Boolean isSeclvAddOrDel = isAddOrDelMap.get(IWaGradeCommonDef.WA_SECLV);
		// ȡѡԱ
		WaPsnhiVO[] psnhiVOs = getSaveParamHelper.getPsnHiVO(aggVO, formDataMap);
		// 鿴ԱԺ͵ԱǷ仯
		Map<String, Boolean> isChangeMap = getSaveParamHelper.prvAndSevIsChange(commonPorp.getWaPsnhiVOArrOld(), psnhiVOs);
		Boolean isWaPsnhiChange = isChangeMap.get(IWaGradeCommonDef.WA_PRMLV);
		Boolean isWaPsnhiSevChange = isChangeMap.get(IWaGradeCommonDef.WA_SECLV);

		aggVO.setTableVO(IWaGradeCommonDef.WA_PRMLV, waPrmlvVOArr);
		aggVO.setTableVO(IWaGradeCommonDef.WA_SECLV, waSeclvVOArr);
		validate.validateDataDuplication(aggVO);
		
		commonPorp.setWaPsnhiChange(isWaPsnhiChange); // ԱǷ仯
		commonPorp.setWaPsnhiSevChange(isWaPsnhiSevChange);// ԱǷ仯
		commonPorp.setPrmlvAddOrDel(isPrmlvAddOrDel); // Ƿӻɾ
		commonPorp.setSeclvAddOrDel(isSeclvAddOrDel);// Ƿӻɾ
		commonPorp.setPsnhiVOs(psnhiVOs);
		commonPorp.setAggVO(aggVO);
		
		// ҵ
		return process(opType, pkWaGrdOld, commonPorp);
	}

	/**
	 * 
	 * 20196274:30:23 msw
	 * 
	 * @param opType
	 * @param pkWaGrdOld
	 * @param psnhiVOs
	 * @param aggVO
	 * @return
	 * @throws BusinessException
	 *
	 */
	private JSONObject process(String opType, String pkWaGrdOld,WaGradeSaveCommonProp commonPorp)
			throws BusinessException {
		StringBuffer warinMsgBf = new StringBuffer();// Ϣ
		AggWaGradeVO aggVO=commonPorp.getAggVO();
		if ("add".equals(opType) || "copy".equals(opType)) {
			// Ƕ൵
			if (!commonPorp.isMultNew()) {
				aggVO.setTableVO(IWaGradeCommonDef.WA_SECLV, null);
			}
			// ƵʱӼ״̬͵Ϊ״̬
			if ("copy".equals(opType)) {
				copyHelper.ensureCopyData(aggVO);
			}
			aggVO.setTableVO(IWaGradeCommonDef.WA_PSNHI, commonPorp.getPsnhiVOs());
			WaItemVO itemvo = WaGradeCommon.getWaItem(aggVO.getParentVO().getPk_wa_item());
			
			//add by@chenzfУ飬ϼΪʱһֻܴ֯нս 2021-4-6 15:20:26 begin
			WaGradeVO waGradeVO = aggVO.getParentVO();
			if(StringUtils.isNotEmpty(waGradeVO.getPk_wagrade_top())) {
				String sql = "pk_wagrade_top = '"+waGradeVO.getPk_wagrade_top()+"' and standard_type = '"+waGradeVO.getStandard_type()+"' and nvl(dr,0) = 0";
				String rst = ServiceLocator.find(IWaGradeQueryService.class).queryWaGradePK(sql);
				if(StringUtils.isNotEmpty(rst)) {
					throw new BusinessException("нʱ׼Ѿһ!");
				}
			}
			//add by@chenzfУ飬ϼΪʱһֻܴ֯нս 2021-4-6 15:20:26 end
			
			// 
			AggWaGradeVO resultVO = ServiceLocator.find(IWaGradeService.class).insertWaGradeVO(aggVO);
			resultVO.getParentVO().setIflddecimal(itemvo.getIflddecimal());
			/*
			 * ƺ ԱϢЧнʱ׼汾Ϣ 1 ԱԷ仯ӦԱݲ
			 * 2൵н꣬ɾɾʱнʱ׼汾Ϣ
			 */
			if ("copy".equals(opType)) {
				copyHelper.copyHandle(resultVO, pkWaGrdOld, warinMsgBf);
			}
		} else if ("edit".equals(opType)) {
			updateHelper.updateHandle(commonPorp.getPsnhiVOs(), aggVO, warinMsgBf);
		}
		boolean val = "".equals(warinMsgBf.toString()) ? true : false;
		JSONObject json = new JSONObject();
		json.put("message", warinMsgBf.toString());
		json.put("success", val);
		json.put("pk", aggVO.getParentVO().getPrimaryKey());
		return json;
	}
}
