package nccloud.web.hrwa.wagrade.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.ITimeService;
import nc.itf.hr.wa.IWaGradeQueryService;
import nc.itf.hr.wa.IWaGradeService;
import nc.vo.bd.pub.NODE_TYPE;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;
import nc.vo.uif2.LoginContext;
import nc.vo.wa.grade.AggWaGradeVO;
import nc.vo.wa.grade.CrtVO;
import nc.vo.wa.grade.WaCriterionVO;
import nc.vo.wa.grade.WaGradeVO;
import nc.vo.wa.grade.WaGradeVerVO;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.hrwa.helper.StringHelper;
import nccloud.web.hrwa.pub.ErrorContent;
import nccloud.web.hrwa.wagrade.save.WaGradeVerHelper;
import nccloud.web.hrwa.wagrade.validation.WaGradeVerValidateHelper;
import nccloud.web.uapbd.commons.web.ParamUtils;
/**
 * 
 * 20197133:06:32
 * msw
 * нʱ׼汾Ϣ
 */
public class WaGradeVerSaveAction extends HRCommonAction {
	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		String headJson = StringHelper.getString(request, "head").replace("crtVOs", "crtVOs_null");
		WaGradeVerVO[] gradeVerVOs = HRNccTemplateUtils.getVOFromGrid(WaGradeVerVO.class, headJson);
		if (ArrayUtils.isEmpty(gradeVerVOs)) {
			return null;
		}
		WaGradeVerVO selectVerVO = new WaGradeVerHelper().getSelectVerVo(gradeVerVOs);
		if (selectVerVO == null) {
			return null;
		}
		String waStaTableData = param.get("sublist").toString();
		if (StringUtils.isBlank(waStaTableData)) {
			throw new BusinessException(ErrorContent.QUERYMETHODNULL);
		}
		WaGradeVerValidateHelper validateHelper = new WaGradeVerValidateHelper();
		WaGradeVerHelper waGradeVerHelper = new WaGradeVerHelper();
		// Ͼۺvo
		AggWaGradeVO aggWaGradeVO = getSelectAggWagradeFromDBByPkWaGrd(selectVerVO.getPk_wa_grd());
		WaGradeVO wagradeVO = (WaGradeVO) aggWaGradeVO.getParentVO();
		waGradeVerHelper.setWaGradeVerVO(selectVerVO, wagradeVO, waStaTableData);
		
		
		//add by@chenzf жǷð汾 1Ϊ 2021-3-16 15:17:26 begin
//		String type = param.get("type").toString();
		LoginContext context = HRNccUtils.getLoginContext(param);
		if("1".equals(selectVerVO.getType())) {
			CrtVO[] crtVOs = selectVerVO.getCrtVOs();
			List<WaCriterionVO> crList = new ArrayList<>();
			if(crtVOs != null && crtVOs.length > 0) {
				for(int i = 0; i < crtVOs.length; i++) {
					crList.add((WaCriterionVO) crtVOs[i].getVecData().get(0));
				}
				selectVerVO.setStatus(VOStatus.NEW);
				selectVerVO.setCriterionvos(crList.toArray(new WaCriterionVO[0]));
			}
		}
		//add by@chenzf жǷð汾 1Ϊ 2021-3-16 15:17:26 
		
		// нĳϲУ
		validateHelper.validate(wagradeVO, selectVerVO, gradeVerVOs);
		// Ϣ
		resetModifyInfo(wagradeVO);
		
		//add by@chenzf ӷΧУУ 2021-4-6 12:19:28 begin
		//()lower000000000000001  ()upper000000000000001
		WaCriterionVO[] waCrtVOs = selectVerVO.getCriterionvos();
		if(waCrtVOs != null && waCrtVOs.length > 0) {
			String msg = "";
			if(wagradeVO.getIsmultsec() != null && wagradeVO.getIsmultsec().booleanValue()) {
				if(StringUtils.isNotBlank(wagradeVO.getPk_wagrade_top())) {
					IWaGradeQueryService iWaGradeQueryService = ServiceLocator.find(IWaGradeQueryService.class);
					WaCriterionVO[] topWaCrtVOs = iWaGradeQueryService.queryByClsPk(wagradeVO.getPk_wagrade_top(), wagradeVO.getIsmultsec().booleanValue(), 1);
					//нkeyΪ+,valueΪ
					Map<String,UFDouble> map = new HashMap();
					//¹ʻս keyΪ+,valueΪ
					Map<String,UFDouble> map2 = new HashMap();
					for(WaCriterionVO topVO : topWaCrtVOs) {
						String prmlvName = topVO.getPrmlvName();
						String seclvName = topVO.getLevName();
						UFDouble value = topVO.getCriterionvalue();
						map.put(prmlvName+"@@"+seclvName, value);
					}
					
					//2Ϊн3Ϊս
					String standard_type = wagradeVO.getStandard_type() != null && wagradeVO.getStandard_type().equals("2") ? "3" : "2";
					if(wagradeVO.getStandard_type() != null && "1".equals(wagradeVO.getStandard_type())) {
						standard_type = "0";
					}
					String sql = "pk_wagrade_top = '"+wagradeVO.getPk_wagrade_top()+"' and standard_type = '"+standard_type+"' and nvl(dr,0) = 0";
					String pkWaGrd = iWaGradeQueryService.queryWaGradePK(sql);
					if(StringUtils.isNotBlank(pkWaGrd)) {
						WaCriterionVO[] crtVOs = iWaGradeQueryService.queryByClsPk(pkWaGrd, wagradeVO.getIsmultsec().booleanValue(), 1);
						if(crtVOs != null && crtVOs.length > 0) {
							for(WaCriterionVO vo : crtVOs) {
								if("lower000000000000001".equals(vo.getPk_wa_seclv()) || "upper000000000000001".equals(vo.getPk_wa_seclv())) {
									continue;
								}
								String prmlvName = vo.getPrmlvName();
								String seclvName = vo.getLevName();
								UFDouble value = vo.getCriterionvalue();
								map2.put(prmlvName+"@@"+seclvName, value);
							}
						}
					}
					UFBoolean check = UFBoolean.FALSE;
					if(wagradeVO.getStandard_type() != null && "2".equals(wagradeVO.getStandard_type())){
						check = UFBoolean.TRUE;
					}
					
					
					for(WaCriterionVO waCrtVO : waCrtVOs) {
						if("lower000000000000001".equals(waCrtVO.getPk_wa_seclv()) || "upper000000000000001".equals(waCrtVO.getPk_wa_seclv())) {
							continue;
						}
						String prmlvName = waCrtVO.getPrmlvName();
						String seclvName = waCrtVO.getLevName();
						UFDouble value = waCrtVO.getCriterionvalue();
						UFDouble value2 =  map2.get(prmlvName+"@@"+seclvName) == null ? UFDouble.ZERO_DBL : map2.get(prmlvName+"@@"+seclvName);
						UFDouble topValue = map.get(prmlvName+"@@"+seclvName);
						UFDouble trueValue = UFDouble.ZERO_DBL;
						if(check.booleanValue()) {
							trueValue = value.multiply(12).add(value2);
						} else {
							trueValue = value.add(value2.multiply(12));
						}
						
						if(trueValue.doubleValue() > topValue.doubleValue()) {
							msg = msg + "[н"+prmlvName+",н"+seclvName+"]";
						}
					}
				}
				if(selectVerVO.getEffect_flag().booleanValue()) {
					if(msg.length() > 0) {
						throw new BusinessException("Ӧн׼*12Ӧս׼֮ڶӦн׼ΧڣΧ޷Ч,ЩݲڷΧ"+msg);
					}
				}
				//֯=֤ǼŽڵ
//				if(wagradeVO.getPk_org().equals(wagradeVO.getPk_group())) {
//					if(context.getNodeType() == NODE_TYPE.GROUP_NODE) {
				UFBoolean isscope = wagradeVO.getIsscope();
				if(isscope != null && isscope.booleanValue()) {
					//keyΪн+нvalueΪֵ
					Map<String,UFDouble> valueMap = new HashMap();
					for(WaCriterionVO waCrtVO : waCrtVOs) {
						String pkWaPrmlv = waCrtVO.getPk_wa_prmlv();
						String pkWaSeclv = waCrtVO.getPk_wa_seclv();
						UFDouble value = waCrtVO.getCriterionvalue();
						if("lower000000000000001".equals(waCrtVO.getPk_wa_seclv()) || "upper000000000000001".equals(waCrtVO.getPk_wa_seclv())) {
							valueMap.put(pkWaPrmlv+"@"+pkWaSeclv, value);
						}
					}
					
					for(WaCriterionVO waCrtVO : waCrtVOs) {
						String pkWaPrmlv = waCrtVO.getPk_wa_prmlv();
						String pkWaSeclv = waCrtVO.getPk_wa_seclv();
						UFDouble value = waCrtVO.getCriterionvalue();
						if("lower000000000000001".equals(waCrtVO.getPk_wa_seclv()) || "upper000000000000001".equals(waCrtVO.getPk_wa_seclv())) {
							continue;
						}
						if(context.getNodeType() == NODE_TYPE.GROUP_NODE) {
							if(value.doubleValue() == 0) {
								continue;
							}
						}
						UFDouble lowerValue = valueMap.get(pkWaPrmlv + "@" + "lower000000000000001");//
						UFDouble upperValue = valueMap.get(pkWaPrmlv + "@" + "upper000000000000001");//
						
						if(value.doubleValue() >= lowerValue.doubleValue() && value.doubleValue() <= upperValue.doubleValue()) {
							
						} else {
							//ڷΧ
							msg = msg+"[н"+waCrtVO.getPrmlvName()+",н"+waCrtVO.getSeclvName()+"]";
						}
					}
					if(msg.length() > 0) {
						throw new BusinessException("µݲ޷Χڣ"+msg);
					}
				}
				if(NODE_TYPE.GROUP_NODE.equals(context.getNodeType())) {
					String msg2 = "";
					//keyΪн+нvalueΪֵ
					Map<String,UFDouble> valueMap = new HashMap();
					for(WaCriterionVO waCrtVO : waCrtVOs) {
						String pkWaPrmlv = waCrtVO.getPk_wa_prmlv();
						String pkWaSeclv = waCrtVO.getPk_wa_seclv();
						UFDouble value = waCrtVO.getCriterionvalue();
						if("lower000000000000001".equals(waCrtVO.getPk_wa_seclv()) || "upper000000000000001".equals(waCrtVO.getPk_wa_seclv())) {
							valueMap.put(pkWaPrmlv+"@"+pkWaSeclv, value);
						}
					}
					List<String> list = new ArrayList();
					for(WaCriterionVO waCrtVO : waCrtVOs) {
						String pkWaPrmlv = waCrtVO.getPk_wa_prmlv();
						if(list.contains(pkWaPrmlv)) {
							continue;
						}
						UFDouble lowerValue = valueMap.get(pkWaPrmlv + "@" + "lower000000000000001");//
						UFDouble upperValue = valueMap.get(pkWaPrmlv + "@" + "upper000000000000001");//
						if(lowerValue.doubleValue() <= upperValue.doubleValue()) {
							list.add(pkWaPrmlv);
						} else {
							list.add(pkWaPrmlv);
							msg2 = msg2+"[н"+waCrtVO.getPrmlvName()+"]";
						}
					}
					if(msg2.length() > 0) {
						throw new BusinessException("µн޲ܴнޣ"+msg2);
					}
				}
			}
		}
			
//		}
		
		//add by@chenzf ӷΧУУ 2021-4-6 12:19:28 end
		
		// 
		WaGradeVerVO verVO = saveWaGradeVer(wagradeVO, selectVerVO);
		// ԱݽУ飬УϢǰ
		JSONObject validataMsgJson = new JSONObject();
		validateHelper.setValidataWaStandTableMsg(validataMsgJson, verVO, wagradeVO, aggWaGradeVO);
		return validataMsgJson;
	}

	/**
	 * 
	 * 20196126:08:26 msw
	 * @param wagradeVO
	 *
	 */
	private void resetModifyInfo(WaGradeVO wagradeVO) {
		wagradeVO.setModifier(SessionContext.getInstance().getClientInfo().getUserid());
		wagradeVO.setModifiedtime(ServiceLocator.find(ITimeService.class).getUFDateTime());
	}
    /**
     * 
     * 20197132:17:15
     * msw
     * @param PkWaGrd
     * @return
     * @throws BusinessException
     * ͨѡݵPkWaGrdҾۺVO
     */
	private AggWaGradeVO getSelectAggWagradeFromDBByPkWaGrd(String PkWaGrd) throws BusinessException {
		return (AggWaGradeVO) ServiceLocator.find(IWaGradeQueryService.class).queryAggWagradeByGrdPK(PkWaGrd);
	}
    /**
     * 
     * 20197132:24:01
     * msw
     * @param wagradeVO
     * @param selectVerVO
     * @return
     * @throws BusinessException
     * нʱ׼汾Ϣ
     */
	private WaGradeVerVO saveWaGradeVer(WaGradeVO wagradeVO, WaGradeVerVO selectVerVO) throws BusinessException {
		return ServiceLocator.find(IWaGradeService.class).processCriterionArray(wagradeVO, selectVerVO);
	}
	
}
