package nccloud.web.hrwa.wagrade.query;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nccloud.commons.lang.ArrayUtils;

import nc.itf.hr.wa.IWaGradeQueryService;
import nc.itf.hr.wa.IWaGradeService;
import nc.lightapp.pubapp.web.template.ref.util.StringUtils;
import nc.vo.pmpub.common.utils.CollectionUtils;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.wa.grade.CrtVO;
import nc.vo.wa.grade.WaCriterionVO;
import nc.vo.wa.grade.WaGradeVO;
import nc.vo.wa.grade.WaGradeVerVO;
import nc.vo.wa.item.WaItemVO;
import nccloud.framework.service.ServiceLocator;
import nccloud.web.hrwa.wagrade.action.util.WaGradeCommon;
import nccloud.web.hrwa.wagrade.action.util.WaGradeUtil;

public class WaStaTableHelper {
	/**
	 * 
	 * 20196115:52:23 msw
	 * @param resultMap
	 * @param prmlvListнƼ
	 * @param seclvListнƼ
	 * @param pkWaGrdнʱ׼
	 * @param gradeVo
	 * @throws BusinessException
	 *
	 */
	public void setStaTable(Map<String, Object> resultMap, List<String> prmlvList, List<String> seclvList,
			String pkWaGrd, WaGradeVO gradeVo) throws BusinessException {
		WaGradeVerVO[] gradeVerVo = ServiceLocator.find(IWaGradeService.class).queryGradeVerByGradePK(pkWaGrd);
		WaItemVO itemvo = WaGradeCommon.getWaItem(gradeVo.getPk_wa_item());
		int decimalPlaces = itemvo.getIflddecimal();
		Map<String, Object> map = new HashMap<String, Object>();
		if (ArrayUtils.isEmpty(gradeVerVo)) {
			map = getWaStaTableData(prmlvList, seclvList, null, decimalPlaces);
			resultMap.put("staTable", map);
			return;
		}
		String pkWaGradever = null;
		for (int i = 0; i < gradeVerVo.length; i++) {
			if (gradeVerVo[i].getEffect_flag().booleanValue()) {
				pkWaGradever = gradeVerVo[i].getPk_wa_gradever();
				break;
			}
		}
		// нʱ׼ЧȥФı׼ݣûЧģչʾı׼Ϊգƽ˵ûЧģԲչʾнʱ׼ݣ
		pkWaGradever = (pkWaGradever == null) ? gradeVerVo[gradeVerVo.length - 1].getPk_wa_gradever() : pkWaGradever;
		CrtVO[] crtVOs = ServiceLocator.find(IWaGradeQueryService.class).queryCriterionByClassid(pkWaGrd, pkWaGradever,
				WaGradeUtil.isTrue(gradeVo.getIsmultsec()));
		if (ArrayUtils.isEmpty(crtVOs)) {// Ϊǰ˺չʾݣձʱشȵ0
			map = getWaStaTableData(prmlvList, seclvList, null, decimalPlaces);
			resultMap.put("staTable", map);
			return;
		}
		map = getWaStaTableData(prmlvList, seclvList, crtVOs, decimalPlaces);
		resultMap.put("staTable", map);
	}
	/**
	 * 
	 * 201961210:29:24 msw
	 * @param prmlvListнƼ
	 * @param seclvListнƼ
	 * @param crtVOsнʱ׼
	 * @param decimalPlacesнĿ
	 * @return
	 * @throws BusinessException
	 * ǰԼ нʱ׼ннǰ˷ʱн+нΪmapҪʾΪvalue
	 * ֻнннΪmapҪʾΪvalue
	 * ֻнннΪmapҪʾΪvalue
	 */
	public Map<String, Object> getWaStaTableData(List<String> prmlvList, List<String> seclvList, CrtVO[] crtVOs,
			int decimalPlaces) throws BusinessException {
		Map<String, Object> waStaTableMap = new HashMap<String, Object>();
		if (!CollectionUtils.isEmpty(prmlvList)) {// н
			for (int k = 0; k < prmlvList.size(); k++) {
				if (!CollectionUtils.isEmpty(seclvList)) {// н
					setWaStaTableDataWithPrmlvWithSeclv(waStaTableMap, prmlvList.get(k), seclvList, crtVOs,
							decimalPlaces);
				} else {// нûн
					setWaStaTableDataWithPrmlvWithoutSeclv(waStaTableMap, prmlvList.get(k), null, crtVOs,
							decimalPlaces);
				}
			}
		} else {
			if (!CollectionUtils.isEmpty(seclvList)) {// ûнн
				setWaStaTableDataWithoutPrmlvWithSeclv(waStaTableMap, null, seclvList, crtVOs, decimalPlaces);
			} else {// ûнҲûнûнʱ׼ݣ
				setWaStaTableDataWithoutPrmlvWithoutSeclv(waStaTableMap, null, null, crtVOs, decimalPlaces);
			}
		}
		return waStaTableMap;
	}
	/**
	 * 
	 * 201961210:29:20 msw
	 * @param waStaTableMap
	 * @param prmlvNameн
	 * @param seclvListнƼ
	 * @param crtVOsнʱ׼
	 * @param decimalPlacesнĿ
	 *
	 */
	private void setWaStaTableDataWithPrmlvWithSeclv(Map<String, Object> waStaTableMap, String prmlvName,
			List<String> seclvList, CrtVO[] crtVOs, int decimalPlaces) {
		for (int j = 0; j < seclvList.size(); j++) {
			if (!ArrayUtils.isEmpty(crtVOs)) {
				setWaStaTableData(crtVOs, waStaTableMap, decimalPlaces, seclvList.get(j), prmlvName);
			} else {// ннûϢ׼
				waStaTableMap.put(prmlvName + seclvList.get(j), getCriterionVo(null, decimalPlaces));
			}
		}
	}
	/**
	 * 
	 * 201961210:29:15 msw
	 * @param waStaTableMap
	 * @param prmlvNameн
	 * @param seclvListнƼ
	 * @param crtVOsнʱ׼
	 * @param decimalPlacesнĿ
	 *
	 */
	private void setWaStaTableDataWithPrmlvWithoutSeclv(Map<String, Object> waStaTableMap, String prmlvName,
			List<String> seclvList, CrtVO[] crtVOs, int decimalPlaces) {
		if (!ArrayUtils.isEmpty(crtVOs)) {// нʱ׼
			setWaStaTableData(crtVOs, waStaTableMap, decimalPlaces, null, prmlvName);
		} else {// нûнûнʱ׼
			waStaTableMap.put(prmlvName, getCriterionVo(null, decimalPlaces));
		}
	}
	/**
	 * 
	 * 201961210:29:12 msw
	 * @param waStaTableMap
	 * @param prmlvNameн
	 * @param seclvListнƼ
	 * @param crtVOsнʱ׼
	 * @param decimalPlacesнĿ
	 *
	 */
	private void setWaStaTableDataWithoutPrmlvWithSeclv(Map<String, Object> waStaTableMap, String prmlvName,
			List<String> seclvList, CrtVO[] crtVOs, int decimalPlaces) {
		for (int j = 0; j < seclvList.size(); j++) {
			if (!ArrayUtils.isEmpty(crtVOs)) {// нʱ׼
				setWaStaTableData(crtVOs, waStaTableMap, decimalPlaces, seclvList.get(j), null);
			} else {// ûнʱ׼
				waStaTableMap.put(seclvList.get(j), getCriterionVo(null, decimalPlaces));
			}
		}
	}
	/**
	 * 
	 * 201961210:29:08 msw
	 * @param waStaTableMap
	 * @param prmlvNameн
	 * @param seclvListнƼ
	 * @param crtVOsнʱ׼
	 * @param decimalPlacesнĿ
	 *
	 */
	private void setWaStaTableDataWithoutPrmlvWithoutSeclv(Map<String, Object> waStaTableMap, String prmlvName,
			List<String> seclvList, CrtVO[] crtVOs, int decimalPlaces) {
		waStaTableMap.put(null, getCriterionVo(null, decimalPlaces));
	}
	/**
	 * 
	 * 201961210:29:04 msw
	 * @param crtVOsнʱ׼
	 * @param waStaTableMap
	 * @param decimalPlacesнĿ
	 * @param seclvNameнƼ
	 * @param prmlvNameн
	 * ǰԼ нʱ׼ннǰ˷ʱн+нΪmapҪʾΪvalue
	 * ֻнннΪmapҪʾΪvalue
	 * ֻнннΪmapҪʾΪvalue
	 *
	 */
	private void setWaStaTableData(CrtVO[] crtVOs, Map<String, Object> waStaTableMap, int decimalPlaces,
			String seclvName, String prmlvName) {
		for (int i = 0; i < crtVOs.length; i++) {
			List<Object> list = crtVOs[i].getVecData();
			for (int t = 0; t < list.size(); t++) {
				WaCriterionVO vo = (WaCriterionVO) list.get(t);
				// нʱ׼ннǰ˷ʱн+нΪmapҪʾΪvalue
				if ((!StringUtils.isEmpty(prmlvName) && prmlvName.equals(vo.getPrmlvName()))
						&& (!StringUtils.isEmpty(seclvName) && seclvName.equals(vo.getSeclvName()))) {
					waStaTableMap.put((prmlvName + seclvName), getCriterionVo(vo, decimalPlaces));
					break;
				}
				// ֻнннΪmapҪʾΪvalue
				if (StringUtils.isEmpty(prmlvName)
						&& (!StringUtils.isEmpty(seclvName) && seclvName.equals(vo.getSeclvName()))) {
					waStaTableMap.put(seclvName, getCriterionVo(vo, decimalPlaces));
					break;
				}
				// ֻнннΪmapҪʾΪvalue
				if (StringUtils.isEmpty(seclvName)
						&& (!StringUtils.isEmpty(prmlvName) && prmlvName.equals(vo.getPrmlvName()))) {
					waStaTableMap.put(prmlvName, getCriterionVo(vo, decimalPlaces));
					break;
				}
			}
		}
	}
	/**
	 * 
	 * 4:26:56 msw
	 * @param vo
	 * @param decimalPlacesнĿ
	 * @return
	 *
	 */
	public WaCriterionVO getCriterionVo(WaCriterionVO vo, int decimalPlaces) {
		if (vo == null) {
			vo = new WaCriterionVO();
		}
		// нʱ׼ĬֵС׼ֵĳһûֵĬΪ0
		setWaStandTableDefaultVal(vo);
		// ͨнĿȣнʱ׼Сֵ׼ֵֵ
		formatWaStandTableValByDecimalPlaces(vo, decimalPlaces);
		return vo;
	}
	/**
	 * 
	 * 20196259:47:34 msw
	 * @param vo
	 * @param decimalPlacesнĿ
	 * ͨнĿȣнʱ׼Сֵ׼ֵֵ
	 */
	private void formatWaStandTableValByDecimalPlaces(WaCriterionVO vo, int decimalPlaces) {
		vo.setMin_value(WaGradeUtil.formatUFDoubleData(vo.getMin_value(), decimalPlaces));
		vo.setCriterionvalue(WaGradeUtil.formatUFDoubleData(vo.getCriterionvalue(), decimalPlaces));
		vo.setMax_value(WaGradeUtil.formatUFDoubleData(vo.getMax_value(), decimalPlaces));
	}

	/**
	 * 
	 * 20196259:44:23 msw
	 * @param vo
	 * нʱ׼ĬֵС׼ֵĳһûֵĬΪ0
	 */
	private void setWaStandTableDefaultVal(WaCriterionVO vo) {
		if (vo.getMin_value() == null) {
			vo.setMin_value(new UFDouble(0));
		}
		if (vo.getCriterionvalue() == null) {
			vo.setCriterionvalue(new UFDouble(0));
		}
		if (vo.getMax_value() == null) {
			vo.setMax_value(new UFDouble(0));
		}
	}
}
