package nccloud.web.hrwa.wagrade.validation;

import java.util.ArrayList;
import java.util.List;

import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;

import nc.bs.logging.Logger;
import nc.hr.utils.ResHelper;
import nc.hr.utils.StringHelper;
import nc.hr.utils.StringPiecer;
import nc.itf.hr.wa.IWaGradeService;
import nc.vo.pub.BusinessException;
import nc.vo.wa.grade.AggWaGradeVO;
import nc.vo.wa.grade.CrtVO;
import nc.vo.wa.grade.IWaGradeCommonDef;
import nc.vo.wa.grade.WaCriterionVO;
import nc.vo.wa.grade.WaGradeVO;
import nc.vo.wa.grade.WaGradeVerVO;
import nc.vo.wa.grade.WaPrmlvVO;
import nc.vo.wa.grade.WaSeclvVO;
import nccloud.framework.service.ServiceLocator;

public class WaGradeValidate {

	public void validateDataDuplication(AggWaGradeVO aggvo) throws BusinessException {
		// AggWaGradeVO aggvo = (AggWaGradeVO) obj;
		WaPrmlvVO[] prmvo = (WaPrmlvVO[]) aggvo.getTableVO(IWaGradeCommonDef.WA_PRMLV);
		WaSeclvVO[] secvo = (WaSeclvVO[]) aggvo.getTableVO(IWaGradeCommonDef.WA_SECLV);
		StringBuffer errMessage = new StringBuffer();
		// ͳһµļظУ
		String gradeName = validatePrmName(prmvo);
		if (StringUtils.isNotBlank(gradeName)) {
			errMessage.append(ResHelper.getString("60130paystd", "060130paystd0247")/* Ϣظ */ + "\n");
			errMessage.append(ResHelper.getString("60130paystd", "060130paystd0248")
					/* λ */ + ResHelper.getString("60130paystd", "060130paystd0171")/* нҳǩ */ + "\n");
			errMessage.append(gradeName);
		}
		if (aggvo.getParentVO().getIsmultsec().booleanValue()) {
			if (null != secvo && secvo.length > 0) {
				if (StringUtils.isNotBlank(errMessage.toString())) {
					errMessage.append(ResHelper.getString("60130paystd", "060130paystd0247")/* Ϣظ */ + "\n");
				}
				// ͳһµĵظУ
				String dangName = validateSecName(secvo);
				if (StringUtils.isNotBlank(dangName)) {
					errMessage.append(ResHelper.getString("60130paystd", "060130paystd0248")
							/* λ */ + ResHelper.getString("60130paystd", "060130paystd0173")/* нҳǩ */ + "\n");
					errMessage.append(dangName);
				}
			} else {
				errMessage.append(ResHelper.getString("60130paystd",
						"060130paystd0221")/* @res "ѡ˶൵дݣ " */);
			}
		}
		if (StringUtils.isBlank(errMessage.toString())) {
			return;
		} else {
			throw new BusinessException(errMessage.toString());
		}
	}

	/**
	 * ͳһµļظУ
	 *
	 * @author xuhw on 2009-12-17
	 * @param prmvo
	 * @param sbErrMessage
	 */
	private String validatePrmName(WaPrmlvVO[] prmvo) {
		if (ArrayUtils.isEmpty(prmvo)) {
			return null;
		}
		// prmNames洢ȫļ
		String[] prmNames = new String[prmvo.length];
		prmNames = StringPiecer.getStrArray(prmvo, WaPrmlvVO.LEVELNAME);
		List<String> listname = new ArrayList<String>();

		StringBuffer message = new StringBuffer();
		// ҳȫͬ
		for (int i = 0; i < prmvo.length - 1; i++) {
			// ѾĲټ
			if (listname.contains(prmNames[i])) {
				continue;
			} else {
				listname.add(prmNames[i]);
			}
			// ¼ͬк
			StringBuffer linename = new StringBuffer();
			for (int j = i + 1; j < prmvo.length; j++) {
				if (prmvo[j].getStatus() == 3) {
					continue;
				}
				if (prmNames[i].equals(prmNames[j])) {
					linename.append(j + 1 + ResHelper.getString("60130paystd", "060130paystd0251"));
				}
			}
			if (StringUtils.isNotBlank(linename.toString())) {
				message.append(ResHelper.getString("60130paystd", "060130paystd0246")/* к */ + (i + 1)
						+ ResHelper.getString("60130paystd", "060130paystd0251")
						+ linename.toString().substring(0, linename.toString().length() - 1)
						+ ResHelper.getString("60130paystd", "060130paystd0252")
						+ ResHelper.getString("60130paystd", "160130paystd0012")/*  */
						+ ResHelper.getString("60130paystd", "060130paystd0253") + prmNames[i] + "\n");
			}
		}
		return message.toString();
	}

	/**
	 * ͳһµĵظУ
	 *
	 * @author xuhw on 2009-12-17
	 * @param secvo
	 * @param sbErrMessage
	 */
	private String validateSecName(WaSeclvVO[] secvo) {
		if (ArrayUtils.isEmpty(secvo)) {
			return null;
		}
		// ¼ѾУ
		List<String> lisSecNames = new ArrayList<String>();
		// ¼н
		String[] secNames = new String[secvo.length];
		secNames = StringPiecer.getStrArray(secvo, WaSeclvVO.LEVELNAME);

		// Ϣеظк
		StringBuffer message = new StringBuffer();
		for (int i = 0; i < secvo.length - 1; i++) {
			if (lisSecNames.contains(secNames[i])) {
				continue;
			} else {
				lisSecNames.add(secNames[i]);
			}
			StringBuffer line = new StringBuffer();
			for (int j = i + 1; j < secvo.length; j++) {
				if (secvo[j].getStatus() == 3) {
					continue;
				}
				if (secNames[i].equals(secNames[j])) {
					line.append(j + 1 + ResHelper.getString("60130paystd", "060130paystd0251"));
				}
			}
			if (StringUtils.isNotBlank(line.toString())) {
				message.append(ResHelper.getString("60130paystd", "060130paystd0246")/* к */ + (i + 1)
						+ ResHelper.getString("60130paystd", "060130paystd0251")
						+ line.toString().substring(0, line.toString().length() - 1)
						+ ResHelper.getString("60130paystd", "060130paystd0252")
						+ ResHelper.getString("60130paystd", "160130paystd0011")/*  */
						+ ResHelper.getString("60130paystd", "060130paystd0253") + secNames[i] + "\n");
			}
		}
		return message.toString();
	}

	/**
	 * 
	 * 3:32:10 
	 * msw
	 * @param gradeverVO
	 * @param waGradeVO
	 * @return
	 * @throws BusinessException
	 *
	 */
	public void busiValidate(WaGradeVerVO gradeverVO, WaGradeVO waGradeVO) throws BusinessException {
		// ҵ֤
		StringBuffer sbErrMessage = new StringBuffer();
		CrtVO[] crtVOs = null;
		validateGradeVerInfo(gradeverVO, sbErrMessage);
		crtVOs = gradeverVO.getCrtVOs();
		if (ArrayUtils.isEmpty(crtVOs)) {
			return;
		}
		// нĳϣУޣޣ׼ֵĹϵ
		if (waGradeVO.getIsrange().booleanValue()) {
			validateCrtRange(crtVOs, sbErrMessage);
		}
	}
	/**
	 * 汾ϢǿĿУ
	 *
	 * @param gradeverVO
	 * @param sbErrMessage
	 * @return
	 */
	private String validateGradeVerInfo(WaGradeVerVO gradeverVO, StringBuffer sbErrMessage) {
		if (gradeverVO == null) {
			Logger.debug("ȷ汾.");
			sbErrMessage.append(ResHelper.getString("60130paystd",
					"060130paystd0149")/* @res "ȷ汾." */);
			return sbErrMessage.toString();
		}
		if (gradeverVO.getGradever_num() == null) {
			Logger.debug("[汾]");
			sbErrMessage.append(ResHelper.getString("60130paystd",
					"060130paystd0150")/* @res "[汾]" */);
		}
		if (StringUtils.isBlank(gradeverVO.getGradever_name())) {
			Logger.debug("[汾]");
			sbErrMessage.append(ResHelper.getString("60130paystd",
					"060130paystd0151")/* @res "[汾]" */);
		}
		if (gradeverVO.getVer_create_date() == null
				|| StringUtils.isBlank(gradeverVO.getVer_create_date().toStdString())) {
			Logger.debug("[汾]");
			sbErrMessage.append(ResHelper.getString("60130paystd",
					"060130paystd0152")/* @res "[汾]" */);
		}
		if (StringUtils.isBlank(sbErrMessage.toString())) {
			return null;
		}
		sbErrMessage.append(ResHelper.getString("60130paystd",
				"060130paystd0153")/* @res "Ϊ!" */);
		return sbErrMessage.toString();
	}

	/**
	 * Унʱ׼ֵĺϷ<BR>
	 * нĳϣ<=׼ֵ<=޵У<BR>
	 *
	 * @return ValidationFailure
	 * @throws BusinessException
	 */
	private String validateCrtRange(CrtVO[] crtVOs, StringBuffer sbErrMessage) throws BusinessException {
		double dblMin = 0;
		double dblBasic = 0;
		double dblMax = 0;
		// ҵ֤
		for (int i = 0; i < crtVOs.length; i++) {
			WaCriterionVO[] criterionvos = (crtVOs[i].getVecData().toArray(new WaCriterionVO[0]));
			for (int j = 0; j < criterionvos.length; j++) {
				dblMin = criterionvos[j].getMin_value().doubleValue();
				dblBasic = criterionvos[j].getCriterionvalue().doubleValue();
				dblMax = criterionvos[j].getMax_value().doubleValue();

				if (dblMin > dblBasic) {
					Logger.debug((i + 1) + " " + "" + (j + 1) + "еֵ" + StringHelper.convertDoubleValue(dblMin, 3)
							+ " ܴ ׼ֵ " + StringHelper.convertDoubleValue(dblBasic, 3));
					sbErrMessage.append((i + 1)
							+ ResHelper.getString("60130paystd",
									"060130paystd0154")/* @res "/ " */
							+ (j + 1)
							+ ResHelper.getString("60130paystd",
									"060130paystd0155")/* @res " [ֵ" */
							+ StringHelper.convertDoubleValue(dblMin, 3)
							+ ResHelper.getString("60130paystd",
									"060130paystd0156")/* @res "] ܴ [׼ֵ " */
							+ StringHelper.convertDoubleValue(dblBasic, 3) + "]  \n");
				} else if (dblBasic > dblMax) {
					Logger.debug((i + 1) + " " + "" + (j + 1) + "еĻ׼ֵ" + StringHelper.convertDoubleValue(dblBasic, 3)
							+ " ܴ ֵ " + StringHelper.convertDoubleValue(dblMax, 3));
					sbErrMessage.append((i + 1)
							+ ResHelper.getString("60130paystd",
									"060130paystd0157")/* @res "/" */
							+ (j + 1)
							+ ResHelper.getString("60130paystd",
									"060130paystd0158")/* @res " [׼ֵ" */
							+ StringHelper.convertDoubleValue(dblBasic, 3)
							+ ResHelper.getString("60130paystd",
									"060130paystd0159")/* @res "] ܴ [ֵ " */
							+ StringHelper.convertDoubleValue(dblMax, 3) + "]  \n");
				}
			}
		}
		if (StringUtils.isBlank(sbErrMessage.toString())) {
			return null;
		} else {
			throw new BusinessException(sbErrMessage.toString());
		}
	}

	/**
	 * нʱ׼汾ЧڵУ
	 *
	 * @param vervos
	 * @throws BusinessException
	 */
	public void validateEffectFlag(WaGradeVerVO[] gradeVerVOs,WaGradeVerVO gradeVer, String pkWaGrd) throws BusinessException {
		if (gradeVer == null || pkWaGrd == null || gradeVer.getEffect_flag() == null) {
			return;
		}
		int intErrorFlag = 0;
		for (WaGradeVerVO vervo : gradeVerVOs) {
			if (vervo.getEffect_flag() != null && vervo.getEffect_flag().booleanValue()) {
				intErrorFlag++;
			}
		}
		if (intErrorFlag == 1) {
			return;
		} else if (intErrorFlag > 1) {
			throw new BusinessException(ResHelper.getString("60130paystd",
					"060130paystd0206")/* @res "һнʱ׼вжЧǱѡУ" */);
		} else {
			IWaGradeService service = ServiceLocator.find(IWaGradeService.class);
			String msg = service.validateGradeHaveReferenceByBusiness(pkWaGrd);
			if (msg != null && !"".equals(msg)) {
				throw new BusinessException(msg);
			}
		}
	}

	/**
	 * 
	 * 12:42:07 
	 * msw
	 * @param aggvo
	 * @throws BusinessException
	 *
	 */
	public void validatePrvSecIsNull(AggWaGradeVO aggvo) throws BusinessException {
		WaPrmlvVO[] prmvo = (WaPrmlvVO[]) aggvo.getTableVO(IWaGradeCommonDef.WA_PRMLV);
		WaSeclvVO[] secvo = (WaSeclvVO[]) aggvo.getTableVO(IWaGradeCommonDef.WA_SECLV);
		String prvSheet = ResHelper.getString("60130paystd",
				"160130paystd0016")/* @res "н" */;
		String sevSheet = ResHelper.getString("60130paystd",
				"160130paystd0018")/* @res "н" */;
		String msg = "";
		String sheetName = ResHelper.getString("_Bill", "UPP_Bill-000003");// ҳǩ
		if (prmvo != null) {
			for (int i = 0; i < prmvo.length; i++) {
				if (prmvo[i].getLevelname() == null) {
					String rowText = ResHelper.getString("6013bnkitf", "06013bnkitf0133") + prmvo[i].getDisplayindex()
							+ ResHelper.getString("60130paystd", "060130paystd0160")/* @res"{0}:" */;
					msg += prvSheet + "(" + sheetName + ")" + rowText + "["
							+ ResHelper.getString("60130paystd", "160130paystd0012")/*  */ + "] ";
				}
			}
		}
		if (!"".equals(msg)) {
			throw new BusinessException(ResHelper.getString("_template", "1-systemplet-00001") + msg);
		}
		if (secvo != null) {
			for (int i = 0; i < secvo.length; i++) {
				if (secvo[i].getLevelname() == null) {
					String rowText = ResHelper.getString("6013bnkitf", "06013bnkitf0133") + secvo[i].getDisplayindex()
							+ ResHelper.getString("60130paystd", "060130paystd0160")/* @res"{0}:" */;
					msg += sevSheet + "(" + sheetName + ")" + rowText + "["
							+ ResHelper.getString("60130paystd", "160130paystd0011")/*  */ + "] ";
				}
			}
		}
		if (!"".equals(msg)) {
			throw new BusinessException(ResHelper.getString("_template", "1-systemplet-00001") + msg);
		}
	}
}
