package nc.impl.wa.paydata;

import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import nccloud.commons.lang.StringUtils;

import nc.bs.dao.DAOException;
import nc.bs.logging.Logger;
import nc.hr.utils.ResHelper;
import nc.itf.hr.wa.IHRWADataResCode;
import nc.itf.hr.wa.WaPowerSqlHelper;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.dataitem.pub.DataVOUtils;
import nc.vo.hi.pub.HICommonValue;
import nc.vo.hr.caculate.CaculateTypeVO;
import nc.vo.hr.pub.FormatVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDouble;
import nc.vo.wa.classitem.WaClassItemVO;
import nc.vo.wa.func.FuncParse;
import nc.vo.wa.func.SqlFragment;
import nc.vo.wa.func.WherePartUtil;
import nc.vo.wa.item.FromEnumVO;
import nc.vo.wa.paydata.DataSVO;
import nc.vo.wa.pub.WaLoginContext;

/**
 *
 *
 * @author: zhangg
 * @date: 2009-11-23 11:18:25
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public class DataCaculateService extends AbstractCaculateService {

	private Set<String> pk_wa_itemSet = null;// ҪֵĿ
	private TaxBindService taxBindService = null;



	/**
	 * @author zhangg on 2010-6-10
	 * @return the taxBindService
	 */
	private TaxBindService getTaxBindService() {
		if (taxBindService == null) {
			taxBindService = new TaxBindService();
		}
		return taxBindService;
	}

	/**
	 * @author zhangg on 2010-5-21
	 * @return the pk_wa_itemSet
	 * @throws DAOException
	 */
	private Set<String> setPk_wa_itemSet() throws DAOException {
		pk_wa_itemSet = new HashSet<String>();
		StringBuffer sqlBuffer = new StringBuffer();
		sqlBuffer.append("select distinct pk_wa_classitem from wa_datas ");
		sqlBuffer.append(" where wa_datas.pk_wa_data in  ");
		sqlBuffer.append("     (select wa_cacu_data.pk_wa_data "); // 2
		sqlBuffer.append("        from wa_cacu_data ");
		sqlBuffer.append("       where wa_cacu_data.pk_wa_class = '" + getLoginContext().getWaLoginVO().getPk_wa_class() + "' )");

		DataSVO[] dataSVOs = executeQueryVOs(sqlBuffer.toString(), DataSVO.class);
		if (dataSVOs != null) {
			for (DataSVO dataSVO : dataSVOs) {
				pk_wa_itemSet.add(dataSVO.getPk_wa_classitem());
			}
		}

		return pk_wa_itemSet;
	}

	/**
	 *
	 * @author zhangg on 2009-9-27
	 * @param selectWhere
	 *            Ӱ쵽pk_wa_dataΧ
	 * @throws DAOException
	 */
	public DataCaculateService(WaLoginContext loginContext, CaculateTypeVO caculateTypeVO, String selectWhere) throws BusinessException {
		super(loginContext);

		// ü㷶Χ
		setWaDataCacuRange4Class(caculateTypeVO, selectWhere);
		// õҪõֵĿset
		setPk_wa_itemSet();

	}


	@Override
	public void doCaculate() throws BusinessException {

		WaClassItemVO[] classItemVOs = getClassItemVOs();
		doCaculate(classItemVOs);

		//˰
		//˰ĸ󣬲нʼʱ˰
//		doPsnTax();


		//״̬
		updateSates();

		//ϣǵ״̬м
		clearMidData();
	}

	public void clearMidData() throws BusinessException {
		//нʼϡǵ״̬ɾwa_cacu_data 

		StringBuffer deleteWa_cacu_data = new StringBuffer();
		deleteWa_cacu_data.append("delete from wa_cacu_data  ");
		deleteWa_cacu_data.append(" where pk_wa_class = '" + getLoginContext().getWaLoginVO().getPk_wa_class() + "' ");
		executeSQLs(deleteWa_cacu_data);

	}


	public void doPsnTax() throws BusinessException {
		new PsntaxService().doPsnTax(getLoginContext());
	}

	/**
	 * ҪΪϲ˰ķ
	 *
	 * @author zhangg on 2010-6-11
	 * @param classItemVOs
	 * @throws BusinessException
	 */
	public void doCaculate(WaClassItemVO[] classItemVOs) throws BusinessException {

		if (classItemVOs == null) {
			return;
		}
		// 
		updateItem2Zero(classItemVOs);

		// 鲢Ƿкϲ˰
		getTaxBindService().doCaculateTaxBind(getLoginContext(),getCacuRangeWhere());

		//нʷűе ѿ˰	ѿ˰	˰	  ͬм˰ʼ㡣
		updateTaxAndRedata(getLoginContext());


		for (WaClassItemVO waClassItemVO : classItemVOs) {

			doCaculateSingle(waClassItemVO);

			// Աݵ
			updateSepecalItem(waClassItemVO);

			
			// ڴ˰⴦f2ۿϼ
			updateF2(waClassItemVO);
			
			//add by longht 20210603 ¼,ȡнʷ˵ݽи 
			recalSingle(waClassItemVO);

		}

	}

	
	/**
	 * @author longht
	 * 20210603
	 * ¼,ȡнʷ˵ݽи 
	 * @param waClassItemVO
	 * @throws BusinessException
	 */
	private void recalSingle(WaClassItemVO waClassItemVO) throws BusinessException {
		// TODO Auto-generated method stub
		String itemkey = waClassItemVO.getItemkey();
		String pk_wa_classitem = waClassItemVO.getPk_wa_classitem();
		String pk_wa_class = waClassItemVO.getPk_wa_class();
		String cyear = waClassItemVO.getCyear();
		String cperiod = waClassItemVO.getCperiod();
		
		//ǷҪ
		String checksql = 
				"select count(1) exsistrow from wa_data_explain wde  where   wde.iscommit = 'Y'\n" +
						" and wde.pk_wa_classitem ='"+pk_wa_classitem+"'\n" + 
						" and wde.pk_wa_class='"+pk_wa_class+"'\n" + 
						" and wde.def1 ='"+cyear+cperiod+"'\n" + 
						" and nvl(wde.dr,0)=0\n" + 
						" and wde.pk_psndoc in (SELECT pk_psndoc FROM wa_data where nvl(dr,0)=0 and pk_wa_class ='"+pk_wa_class+"'\n" + 
						" and cyearperiod = '"+cyear+cperiod+"' )";
		HashMap existsrow  = (HashMap) getBaseDao().executeQuery(checksql.toString(),  new MapProcessor());
		if(null!=existsrow) {
			int existrow =Integer.parseInt(existsrow.get("exsistrow").toString()) ;
			if(existrow<=0)
				return;
				
		}else {
			return;
		}
					
		String upsql =
				"update wa_data wd set "+itemkey+" =\n" +
						"( select wde.money from wa_data_explain wde\n" + 
						"  where wde.pk_psndoc = wd.pk_psndoc\n" + 
						"  and wde.iscommit = 'Y'\n" + 
						"  and wde.pk_wa_classitem ='"+pk_wa_classitem+"'\n" + 
						"  and wde.pk_wa_class ='"+pk_wa_class+"'\n" + 
						"  and wde.def1 ='"+cyear+cperiod+"'\n" + 
						"  and nvl(wde.dr,0)=0\n" + 
						"  ) where wd.pk_wa_class ='"+pk_wa_class+"'\n" + 
						"  and wd.cyearperiod = '"+cyear+cperiod+"'" +
                        " and pk_psndoc in (select pk_psndoc from wa_data_explain wde  where   wde.iscommit = 'Y'\n" +
						" and wde.pk_wa_classitem ='"+pk_wa_classitem+"'\n" + 
						" and wde.pk_wa_class='"+pk_wa_class+"'\n" + 
						" and wde.def1 ='"+cyear+cperiod+"'\n" + 
						" and nvl(wde.dr,0)=0\n" + 
						" and wde.pk_psndoc in (SELECT pk_psndoc FROM wa_data where nvl(dr,0)=0 and pk_wa_class ='"+pk_wa_class+"'\n" + 
						" and cyearperiod = '"+cyear+cperiod+"' ))";

		   executeSQLs(upsql);
		   
		//Ϊ״̬
		String yysql = 
			"update wa_data_explain wde set wde.isquote = 'Y' where   wde.iscommit = 'Y'\n" +
			" and wde.pk_wa_classitem ='"+pk_wa_classitem+"'\n" + 
			" and wde.pk_wa_class='"+pk_wa_class+"'\n" + 
			" and wde.def1 ='"+cyear+cperiod+"'\n" + 
			" and nvl(wde.dr,0)=0\n" + 
			" and wde.pk_psndoc in (SELECT pk_psndoc FROM wa_data where nvl(dr,0)=0 and pk_wa_class ='"+pk_wa_class+"'\n" + 
			" and cyearperiod = '"+cyear+cperiod+"' )";
		
		executeSQLs(yysql);	 
		
	}

	/**
	 * ڴ˰ϵͳĬϹʽУ ο˰뱾β˰ǲӦüۿϼƵ
	 * @param itemVO
	 * @throws BusinessException
	 */
	private void updateF2(WaClassItemVO itemVO) throws BusinessException {
		if (itemVO.getItemkey().equalsIgnoreCase("f_2") && itemVO.getIssysformula().booleanValue()) {// ϵͳĿͻûб仯.
			String sql = "update wa_data set f_2 = (f_2 - f_5 - f_9) " + getCacuRangeWhere() + " and wa_data.taxtype = 1";
			executeSQLs(sql);
		}
	}

	/**
	 * ⼸Ŀûṩʽ f_6 ѿ˰ f_7 ѿ˰ f_8  f_9 ˰
	 *
	 * @author zhangg on 2010-6-4
	 * @param itemVO
	 * @return
	 */
	private boolean isF6TOF9(WaClassItemVO itemVO) {
		return (itemVO.getItemkey().equalsIgnoreCase("f_6") || itemVO.getItemkey().equalsIgnoreCase("f_7") || itemVO.getItemkey().equalsIgnoreCase("f_8") || itemVO.getItemkey()
				.equalsIgnoreCase("f_9"));
	}

	/**
	 * нĿ
	 *
	 * @author zhangg on 2009-9-28
	 * @throws DAOException
	 * @throws BusinessException
	 */
	private void doCaculateSingle(WaClassItemVO itemVO) throws BusinessException {
		try {
			getLoginContext().setInitData(itemVO);
			getLoginContext().getWaLoginVO().setClassItemVOs(this.classItemVOs);

			if (itemVO == null) {
				return;
			}
			if (isF6TOF9(itemVO)) {
				return;
			}
			// ֹ룬 
			if (itemVO.getIfromflag().equals(FromEnumVO.USER_INPUT.value())) {
				return;
			}
			// ǹ̶ֵ
			if (itemVO.getIfromflag().equals(FromEnumVO.FIX_VALUE.value())) {
				updateConstantItem(itemVO);
				return;
			}

			if (itemVO.getVformula() == null) {
				return;
			}
			// ʽԴ
			if (!itemVO.getIfromflag().equals(FromEnumVO.FORMULA.value())) {
				execute(itemVO);
				//нȡ籣ĿֵͶѡȡֵҪжǷ㴦
				if(itemVO.getIfromflag().equals(FromEnumVO.BM.value()) && itemVO.getIitemtype()==0){
					String param = itemVO.getVformula().substring(itemVO.getVformula().indexOf("(" )+1, itemVO.getVformula().indexOf(")" ));
			        String[] params = param.split( ",");
			        if(params.length==4){
					       //ȡֵûѡʱ㣨Ϊf_f
						if(params[3]!=null&&!params[3].equals("f_f")){
							updateBmItem(itemVO);
						}
			        }
				}
			} else if (itemVO.getVformula() != null) {
				IPreTranslate waPreTranslate =new WaPreTranslate();
				String formua= waPreTranslate.parse(itemVO.getPk_org(), itemVO.getVformula());
				itemVO.setVformula(formua);
				List<SqlFragment> fragmentList = FuncParse.parse(formua);
				if (fragmentList != null && fragmentList.size() > 0) {
					for (SqlFragment sqlFragment : fragmentList) {
						execute(itemVO, sqlFragment);
					}
				}
			}
		} catch (Exception e) {
			if (e instanceof DAOException) {
				throw new BusinessException(ResHelper.getString("60130paydata","060130paydata0444")/*@res "нĿ:"*/ + itemVO.getMultilangName() + ResHelper.getString("60130paydata","060130paydata0445")/*@res "ʽô 顣"*/);

			} else if (e instanceof BusinessException) {
				throw (BusinessException) e;
			} else {
				throw new BusinessException(e);
			}
		}
	}
	/**
	 * 籣Ŀȡֵ˽㣬ֻΪNʱΪ0
	 *
	 * @author guoqt on 2014-5-30
	 * @throws DAOException
	 */
	private void updateBmItem(WaClassItemVO itemVO) throws DAOException {
		String where = getCacuRangeWhere();
		String sql = "update wa_data set wa_data." + itemVO.getItemkey() + " = 0 " + where;
        String param = itemVO.getVformula().substring(itemVO.getVformula().indexOf("(" )+1, itemVO.getVformula().indexOf(")" ));
        String[] params = param.split( ",");
        StringBuilder sbd = new StringBuilder();
		sbd.append("  and wa_data.pk_wa_data in ( select pk_wa_data from wa_data where pk_wa_class = ? and cyear= ? and cperiod= ?  ");
		sbd.append("  and wa_data." + params[3] + " in ('N','n') ) ");
		sql= sql+sbd.toString();
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(itemVO.getPk_wa_class());
		parameter.addParam(itemVO.getCyear());
		parameter.addParam(itemVO.getCperiod());
		getBaseDao().executeUpdate(sql, parameter);
	}
	private void execute(WaClassItemVO itemVO) throws BusinessException {
		String formula = itemVO.getVformula();
		formula = parse(formula);
		SqlFragment sqlFragment = new SqlFragment();
		sqlFragment.setValue(formula);
		execute(itemVO, sqlFragment);
	}

	private void execute(WaClassItemVO itemVO, SqlFragment sqlFragment) throws BusinessException {

		try {
			if(!StringUtils.isBlank(sqlFragment.getValue())){
				getBaseDao().executeUpdate(translate2ExecutableSql(itemVO, sqlFragment));
			}
			updateDigits(itemVO);
		} catch (Exception e) {
			Logger.error(e.getMessage(),e);
			throw new BusinessException(ResHelper.getString("60130paydata","060130paydata0444")/*@res "нĿ:"*/ + itemVO.getMultilangName() + ResHelper.getString("60130paydata","060130paydata0445")/*@res "ʽô 顣"*/);
		}
	}

	/**
	 * ¹̶ĿĿ
	 *
	 * @author zhangg on 2009-9-27
	 * @throws DAOException
	 */
	private void updateItem2Zero(WaClassItemVO... itemVOs) throws DAOException {
		String where = getCacuRangeWhere();
		List<String> items = new LinkedList<String>();
		for (WaClassItemVO itemVO : itemVOs) {
			// ֹ룬 
			if (needUpdate2Zero(itemVO)) {
				if (DataVOUtils.isDigitsAttribute(itemVO.getItemkey())) {
					items.add("wa_data." + itemVO.getItemkey() + " = 0 ");
				} else {
					items.add("wa_data." + itemVO.getItemkey() + " = null ");
				}
			}
		}
		String sql = "update wa_data set " + FormatVO.formatListToString(items, "") + where;
		getBaseDao().executeUpdate(sql);
	}

	/**
	 *
	 * @param itemVO
	 * @return
	 */
	private boolean needUpdate2Zero(WaClassItemVO itemVO){
		//жһĿڷżǰǷҪգf_6\f_7\f_8\f_9 Ҫ
		//ֹĿҪ

		if(itemVO.getItemkey().equals("f_6") ||
				itemVO.getItemkey().equals("f_7")||
				itemVO.getItemkey().equals("f_8")||
				itemVO.getItemkey().equals("f_9")
				){
			return false;
		}
		//ֹ룬Ҫ
		if(itemVO.getIfromflag().equals(FromEnumVO.USER_INPUT.value())){
			return false;
		}

		//ʣĿҪȥ
		return true;
	}

	/**
	 *
	 * @param itemVOs
	 * @throws DAOException
	 */
	private void updateTaxAndRedata(WaLoginContext context) throws DAOException {

		StringBuilder sbd = new StringBuilder();
		sbd.append(" update wa_cacu_data   set taxed=  (select f_7  from wa_data where wa_data.pk_wa_data = wa_cacu_data.pk_wa_data), ");
		sbd.append(" taxedBase=  (select f_6  from wa_data where wa_data.pk_wa_data = wa_cacu_data.pk_wa_data), ");
		sbd.append(" retaxed= ( select f_9  from wa_data where wa_data.pk_wa_data = wa_cacu_data.pk_wa_data), ");
		sbd.append(" redata =  (select f_8  from wa_data where wa_data.pk_wa_data = wa_cacu_data.pk_wa_data) ");



		sbd.append( " where wa_cacu_data.pk_wa_class = '"+ context.getPk_wa_class()+"' " );
		getBaseDao().executeUpdate(sbd.toString());
	}




	/**
	 * ¹̶ĿĿ
	 *
	 * @author zhangg on 2009-9-27
	 * @throws BusinessException
	 */
	private void updateSepecalItem(WaClassItemVO itemVO) throws BusinessException {
		if (!pk_wa_itemSet.contains(itemVO.getPk_wa_classitem())) {
			return;
		}

		// wa_datasеļֵ
		StringBuffer sqlBuffer = new StringBuffer();
		sqlBuffer.append("update wa_datas "); // 1
		sqlBuffer.append("   set wa_datas.caculatevalue = (select " + itemVO.getItemkey() + " "); // 2
		sqlBuffer.append("                                   from wa_data ");
		sqlBuffer.append("                                  where wa_data.pk_wa_data = ");
		sqlBuffer.append("                                        wa_datas.pk_wa_data) ");
		sqlBuffer.append(" where wa_datas.pk_wa_data in  ");
		sqlBuffer.append("     (select wa_cacu_data.pk_wa_data "); // 2
		sqlBuffer.append("        from wa_cacu_data ");
		sqlBuffer.append("       where wa_cacu_data.pk_wa_class = '" + getLoginContext().getWaLoginVO().getPk_wa_class() + "' )");
		sqlBuffer.append("       and wa_datas.pk_wa_classitem = '" + itemVO.getPk_wa_classitem() + "'");
		String updateWa_datasSql = sqlBuffer.toString();

		// wa_dataеֵ
		String where = getCacuRangeWhere() + " and wa_data.pk_wa_data in (select pk_wa_data from wa_datas where pk_wa_classitem = '" + itemVO.getPk_wa_classitem() + "') ";

		sqlBuffer = new StringBuffer();
		sqlBuffer.append("update wa_data "); // 1
		sqlBuffer.append("   set " + itemVO.getItemkey() + " = (select value "); // 2
		sqlBuffer.append("                from wa_datas ");
		sqlBuffer.append("               where wa_datas.pk_wa_data = wa_data.pk_wa_data and wa_datas.pk_wa_classitem = '" + itemVO.getPk_wa_classitem() + "') ");
		sqlBuffer.append(where);

		String updateWa_dataSql = sqlBuffer.toString();
		executeSQLs(updateWa_datasSql, updateWa_dataSql);
	}

	@Override
	public String getCacuRangeWhere() {
		return WherePartUtil.addWhereKeyWord2Condition(WherePartUtil.getCacuRange(getLoginContext().getWaLoginVO()));
	}

	/**
	 * ¹̶ĿĿ
	 *
	 * @author zhangg on 2009-9-27
	 * @throws DAOException
	 */
	private void updateConstantItem(WaClassItemVO itemVO) throws DAOException {
		String where = getCacuRangeWhere();
		String sql = "update wa_data set wa_data." + itemVO.getItemkey() + " = ? " + where;
		SQLParameter parameter = new SQLParameter();
		parameter.addParam(itemVO.getVformula());
		getBaseDao().executeUpdate(sql, parameter);
	}

	/**
	 * ͬsetWaDataCacuRange4PsnòͬĲ
	 *
	 * @author zhangg on 2010-5-18
	 * @param where
	 * @throws BusinessException
	 */

	private void setWaDataCacuRange4Class(CaculateTypeVO caculateTypeVO, String where) throws BusinessException {
		if(caculateTypeVO != null){
			// 㷶Χ
			boolean all = caculateTypeVO.getRange().booleanValue();
			if (StringUtils.isEmpty(where)|| all) {
				where = null;
			}

			// 㷽ʽ
			boolean type = caculateTypeVO.getType().booleanValue();
			if (type) {
				String addWhere = "  wa_data.checkflag = 'N'  ";
				where = where == null ? addWhere : (where + " and   " + addWhere);
			} else {
				String addWhere = "  wa_data.checkflag = 'N' and wa_data.caculateflag = 'N'   ";
				where = where == null ? addWhere : (where + " and   " + addWhere);
			}
		}
		//ҵȨ
		//		String poweConditon = DataPermissionUtils.getDataPermissionSQLWherePart(IHRWADataResCode.WADATA, IHRWAActionCode.CALCULATE);

		//		String poweConditon = WaPowerSqlHelper.getWaPowerSql("",IHRWADataResCode.WADATA, IHRWAActionCode.CALCULATE,"");
		//        //  add
		//		if (where == null) {
		//			where = poweConditon;
		//		} else {
		//			where = where + WherePartUtil.formatAddtionalWhere(poweConditon);
		//		}
		//ȨguoqtʹȨ
		StringBuffer wherepart = new StringBuffer();
		wherepart.append(where);
		String powerSql = WaPowerSqlHelper.getWaPowerSql(getLoginContext().getWaLoginVO().getPk_group(),
                HICommonValue. RESOUCECODE_6007PSNJOB,IHRWADataResCode.WADEFAULT,"wa_data");
        if (!StringUtil.isEmptyWithTrim(powerSql) && where!=null) {
        	wherepart.append( " and " + powerSql);
        	where=wherepart.toString();
        }
        
		setWaDataCacuRange4Class(where);

	}



	/**
	 * ±־״̬
	 *
	 * @author zhangg on 2009-9-27
	 * @throws DAOException
	 */
	private void updateSates() throws BusinessException {
		String where = getCacuRangeWhere();
		String sql = "update wa_data set  wa_data.caculateflag = 'Y' " + where;

		getBaseDao().executeUpdate(sql);

		// liangxrжǷѾȫ㣬ȫ޸ڼ״̬
		where = WherePartUtil.getCommonWhereCondtion4Data(getLoginContext().getWaLoginVO());
		sql = "select 1 from wa_data where caculateflag = 'N' and stopflag = 'N' and " + where;
		if (!isValueExist(sql)) {
			where = WherePartUtil.getCommonWhereCondtion4PeriodState(getLoginContext().getWaLoginVO());
			updateTableByColKey("wa_periodstate", "caculateflag", UFBoolean.TRUE, where);
		}
	}
	/**
	 *
	 * @author zhangg on 2010-7-27
	 * @param itemVO
	 * @throws BusinessException
	 */
	private void updateDigits(WaClassItemVO itemVO) throws BusinessException {
		if (DataVOUtils.isDigitsAttribute(itemVO.getItemkey())) {

			int digits = itemVO.getIflddecimal();
			/**
			 * 룬 λ λ нṩĽзʽͬͨϵĽλͬ £
			 *
			 * Сλӽλʽ,ѡ,ϵͳṩλ λλʽ
			 * λû趨Сλ,Сλĵĺһλ0ʱСλһλ1
			 * λû趨Сλ,ۼСλĺһλǷ0,ֱ
			 * ,û趨Сλ,СλĺһλĹнλλ
			 */

			if (itemVO.getRound_type() == null || itemVO.getRound_type().intValue() == 0) {// 

				// String where = getCacuRangeWhere();
				// String sql = "update wa_data set wa_data." +
				// itemVO.getItemkey() + " = round((wa_data." +
				// itemVO.getItemkey() + "), " + digits + " )" + where;
				// executeSQLs(sql);
			} else {
				UFDouble f = UFDouble.ZERO_DBL;
				if (itemVO.getRound_type().intValue() == 1) {// λ
					f = new UFDouble(0.4f);
				} else if (itemVO.getRound_type().intValue() == 2) {// λ
					f = new UFDouble(-0.5f);
				} else {// Ĭ
					f = UFDouble.ZERO_DBL;
				}

				f = f.multiply(Math.pow(0.1, digits));
				String where = getCacuRangeWhere() + " and wa_data." + itemVO.getItemkey() + " > 0";
				String sql = "update wa_data set wa_data." + itemVO.getItemkey() + " = round(((wa_data." + itemVO.getItemkey() + ") + " + f + "), " + digits + " )" + where;

				String where1 = getCacuRangeWhere() + " and wa_data." + itemVO.getItemkey() + " < 0";
				f = f.multiply(-1);
				String sql1 = "update wa_data set wa_data." + itemVO.getItemkey() + " = round(((wa_data." + itemVO.getItemkey() + ") + " + f + "), " + digits + " )" + where1;

				executeSQLs(sql, sql1);
			}

		}

	}


}