package nc.impl.wa.rule;

import nc.bs.bd.cache.CacheProxy;
import nc.bs.dao.DAOException;
import nc.bs.logging.Logger;
import nc.hr.frame.persistence.BaseDAOManager;
import nc.hr.frame.persistence.SimpleDocServiceTemplate;
import nc.hr.utils.ResHelper;
import nc.itf.hr.wa.IWaRuleExService;
import nc.vo.hrwa.waruleex.AggWageformExVO;
import nc.vo.hrwa.waruleex.WageformExVO;
import nc.vo.hrwa.waruleex.WageformdetExVO;
import nc.vo.hrwa.waruleexorg.WageformExOrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVOUtil;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.util.AuditInfoUtil;
import nc.vo.wa.rule.WageformVO;
import nc.vo.wabm.util.WaCacheUtils;

/**
 * WaRuleAppImpl
 *
 * @author: xuhw
 * @date: 2009-11-12 01:56:16
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public class WaRuleExAppImpl implements IWaRuleExService
{
	private final String DOC_NAME = "waruleex";
	private SimpleDocServiceTemplate serviceTemplate;
	private BaseDAOManager basedao = null;

	/**
	 * ɾнʹ<BR>
	 * ɾ֮ǰҪǷӦõУ飬ܱɾ<BR>
	 *
	 * @author xuhw on 2009-11-12
	 */
	@Override
	public void deleteVO(AggWageformExVO vo) throws BusinessException
	{
		// ɾ֮ǰҪǷӦõУ飬ܱɾ
		if (gradeHaveItemReference(vo.getParentVO().getPrimaryKey()))
		{
			Logger.debug("ɾʧܣнʱ׼ѾĿнʷĿ!");
			throw new BusinessException(ResHelper.getString("60130payrule","060130payrule0014")/*@res "ɾʧܣнʱ׼ѾĿнʷĿ!"*/);
		}
		getServiceTemplate().delete(vo);
		CacheProxy.fireDataDeleted(WageformExVO.getDefaultTableName(), vo.getParentVO().getPrimaryKey());
	}

	/**
	 * нʹ
	 *
	 * @author xuhw on 2009-11-12
	 */
	@Override
	public AggWageformExVO insertVO(AggWageformExVO billVO) throws BusinessException
	{
		WaCacheUtils.synCache(WageformExVO.getDefaultTableName());
		return sortVO(getServiceTemplate().insert(billVO));
	}

	/**
	 * нʹ
	 *
	 * @author xuhw on 2009-11-12
	 */
	@Override
	public AggWageformExVO updateVO(AggWageformExVO billVO) throws BusinessException
	{
		WaCacheUtils.synCache(WageformExVO.getDefaultTableName());
		return sortVO(getServiceTemplate().update(billVO,true));
	}

	/**
	 * нʹ
	 *
	 * @author xuhw on 2009-11-12
	 */
	@Override
	public Object copyTable(AggWageformExVO billVO) throws BusinessException
	{
		// ޸״̬
		billVO.getParentVO().setStatus(VOStatus.NEW);
		// 
		billVO.getParentVO().setPrimaryKey(null);
		// ӱ
		for (int i = 0; i < billVO.getChildrenVO().length; i++)
		{
			((WageformdetExVO) billVO.getChildrenVO()[i]).setPk_wa_wageformdetex(null);
			((WageformdetExVO) billVO.getChildrenVO()[i]).setStatus(VOStatus.NEW);
		}
		// Ϣ
		resetAudit((WageformExVO) billVO.getParentVO());
		WaCacheUtils.synCache(WageformVO.getDefaultTableName());
		return sortVO(getServiceTemplate().insert(billVO));
	}

	/**
	 * ӱvo
	 */
	private AggWageformExVO sortVO(AggWageformExVO billVO)
	{
		WageformdetExVO[] wageFormDetVOs = (WageformdetExVO[]) billVO.getChildrenVO();
		if (wageFormDetVOs != null)
		{
			//NCdp205566113 20150727 shenliangc нʹӱ޷ԭArrays.sortʧЧ jdk1.7ִ⡣
			SuperVOUtil.sortByAttributeName(wageFormDetVOs, WageformdetExVO.ILEVEL, true);
//			Arrays.sort(wageFormDetVOs, new WaRuleComparator());
		}
		billVO.setChildrenVO(wageFormDetVOs);
		return billVO;
	}

	/**
	 * ʱϢ
	 *
	 * @author xuhw on 2009-11-12
	 * @param vo
	 */
	private void resetAudit(WageformExVO vo)
	{
		// 
		vo.setAttributeValue(WageformExVO.CREATOR, AuditInfoUtil.getCurrentUser());
		// ʱ
		vo.setAttributeValue(WageformExVO.CREATIONTIME, AuditInfoUtil.getCurrentTime());
		// ޸
		vo.setAttributeValue(WageformExVO.MODIFIER, null);
		// ޸ʱ
		vo.setAttributeValue(WageformExVO.MODIFIEDTIME, null);
	}

	/**
	 * жнʹǷнʹĿĿ
	 *
	 * @author xuhw on 2009-11-28
	 * @param strGrdPk
	 * @return
	 * @throws DAOException
	 */
	private boolean gradeHaveItemReference(String strRulePk) throws DAOException
	{
		// ifromflag=1 ʾԴнʹ
		StringBuffer sbsql = new StringBuffer();
		sbsql.append(" select 3 ");
		sbsql.append("   from wa_item item ");
		sbsql.append("  where (item.ifromflag = '1' and ");
		sbsql.append("        item.vformula like  '%" + strRulePk + "%' ) ");
		sbsql.append(" union ");
		sbsql.append(" select 2 ");
		sbsql.append("   from wa_classitem classitem ");
		sbsql.append("  where ");
		sbsql.append("  (classitem.ifromflag = '1' and ");
		sbsql.append("  classitem.vformula like '%" + strRulePk + "%' )");
		return getBaseDaoManager().isValueExist(sbsql.toString());
	}

	private SimpleDocServiceTemplate getServiceTemplate()
	{
		if (serviceTemplate == null)
		{
			serviceTemplate = new SimpleDocServiceTemplate(DOC_NAME);
		}
		return serviceTemplate;
	}

	private BaseDAOManager getBaseDaoManager()
	{
		if (basedao == null)
		{
			basedao = new BaseDAOManager();
		}
		return basedao;
	}

	@Override
	public void instertWageformExOrgVO(WageformExOrgVO[] vos) throws BusinessException {
		getBaseDaoManager().insertVOArrayReturnVOArray(vos);
	}

	@Override
	public int updateEnable(String pkWageformEx, Boolean isenable) throws BusinessException {
		String enable = isenable ? "Y" : "N";
		String updateSql = "update WA_WAGEFORMEX set ISENABLE = '"+enable+"' where pk_wa_wageformex = '"+pkWageformEx+"' and dr = 0";
		int rst = getBaseDaoManager().getBaseDao().executeUpdate(updateSql);
		return rst;
	}
}